/* 

	Threaded tasks framework.  
	Default CVwTask may be used, or inherit then override CanCancel and OnDestroy.

	The actual task implementations tend to have a CVwAbc for the options dialog, 
	CVwTaskAbc for the thread progress and TaskAbc() for the thread execution.
	
	------------------------------------------
	-- TaskSleep : Sample task startup code --
	CVwTask * pVw = new CVwTask( );
	HWND hVwTask = pVw->CreateTaskWindow( g_hClientWin, g_szChildClass );
	pVw->m_hThread = CreateThread( NULL, 0, TaskSleep, hVwTask, 0, NULL );
	
	DWORD WINAPI TaskSleep( LPVOID pData );		// an example Task 

	//-----------------------------------------------------------------
	DWORD WINAPI TaskSleep( LPVOID pData ) { 
		CVwTask * pVwTask = (CVwTask *) pData;

		for( int i=0; i<100; ++i ) { 
			//-- Do something useful here .... 
			Sleep(33);
			
			//-- Update the pct complete 
			SendMessage( pVwTask->m_hDlg, WM_TASKSETPCT, i, 0 );

			//-- update subtitle text 
			if( i==90 ) 
				SendMessage( pVwTask->m_hDlg, WM_TASKSETTEXT, (WPARAM)"Almost done", 0 );
			
			//-- check if cancelled 
			if( pVwTask->m_bCancelled ) 
				break;
				
			}
			
		SendMessage( (HWND)pVwTask->m_hDlg, WM_TASKCOMPLETE, 0, 0 );
		return -1;
		}

*/

const UINT WM_TASKSETPCT = WM_USER + 1;		// Set % complete in task 
const UINT WM_TASKCOMPLETE = WM_USER + 2;	// notification when task is complete 
const UINT WM_TASKSETTEXT = WM_USER + 3;		// Set text in subtitle

/*
class CTaskOptions { 
	public : 
		CTaskOptions( int iBufferLength, const char * pchRegKey );
		int m_iBufferLength;
		char * m_achBuffer;
		CString m_cRegKey;
		
		void SaveValue( );
		void LoadValue(  );
	};
*/	
	
class CVwTask : public CDialog { 
	private :
		int m_iPct;

	public : 
		HANDLE m_hThread;
		bool m_bCancelled;

		CVwTask( );			
		virtual ~CVwTask( );
		void SetPct( int iPct );
		int GetPct();
		void SetText(const char * pch);		
		void OnPaint();
		void OnCancel();
		HWND CreateTaskWindow( HWND hMain, const char * g_szChildClass );
		virtual bool CanCancel();		// override this with logic whether it is safe to cancel
		virtual void OnDestroy();		// override this with logic to terminate the task if it is still active.
	};

BOOL CALLBACK TaskViewDlgProc(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam);

